Bug 1245962 - Review Request: golang-github-petar-GoLLRB - Left-Leaning Red-Black implementation of balanced binary search trees
Summary: Review Request: golang-github-petar-GoLLRB - Left-Leaning Red-Black implement...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Athos Ribeiro
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-07-23 08:36 UTC by Jan Chaloupka
Modified: 2017-06-15 09:21 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-06-15 03:00:31 UTC
Type: ---
athoscribeiro: fedora-review+


Attachments (Terms of Use)

Description Jan Chaloupka 2015-07-23 08:36:48 UTC
Spec URL: https://jchaloup.fedorapeople.org/reviews/golang-github-petar-GoLLRB/golang-github-petar-GoLLRB.spec

SRPM URL: https://jchaloup.fedorapeople.org/reviews/golang-github-petar-GoLLRB/golang-github-petar-GoLLRB-0-0.1.git53be0d3.fc20.src.rpm

Description: Left-Leaning Red-Black implementation of balanced binary search trees

Fedora Account System Username: jchaloup

Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=10447304

$ rpmlint golang-github-petar-GoLLRB-0-0.1.git53be0d3.fc20.src.rpm golang-github-petar-GoLLRB-devel-0-0.1.git53be0d3.fc20.noarch.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.

Comment 1 Athos Ribeiro 2017-05-01 23:40:37 UTC
Hello Jan,

I will take this review.

Would you like to regenerate the spec file with a newer version of gofed before we go on to better comply with the guidelines draft?

Comment 2 Jan Chaloupka 2017-05-02 08:38:58 UTC
Done

Comment 3 Jan Chaloupka 2017-05-02 08:39:22 UTC
Spec URL: https://jchaloup.fedorapeople.org/reviews/golang-github-petar-GoLLRB/golang-github-petar-GoLLRB.spec

SRPM URL: https://jchaloup.fedorapeople.org/reviews/golang-github-petar-GoLLRB/golang-github-petar-GoLLRB-0-0.1.git53be0d3.fc24.src.rpm

Description: Left-Leaning Red-Black implementation of balanced binary search trees

Fedora Account System Username: jchaloup

Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=19365537

$ rpmlint golang-github-petar-GoLLRB-0-0.1.git53be0d3.fc24.src.rpm golang-github-petar-GoLLRB-devel-0-0.1.git53be0d3.fc24.noarch.rpm golang-github-petar-GoLLRB-unit-test-devel-0-0.1.git53be0d3.fc24.x86_64.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.

Comment 4 Athos Ribeiro 2017-05-02 17:59:58 UTC
The spec file in the URL differs from the one in the SRPM. I am reviewing the newer one (in the SRPM).

- The file example/ex1.go seems to be documentation, not part of the -devel subpackage code.

- There are new guidelines for the Release: tag for snapshots. For instance, the date the snapshot was taken must be present (this should be updated in gofed). See [1] and [2] for reference.

Please, move ex1.go to a %doc tag and update the release tag to comply with the new guidelines before building the package. I will trust you will follow the new guidelines and will not block this review. The package looks good.

Approved.


[1] https://fedoraproject.org/wiki/Packaging:Versioning
[2] https://fedoraproject.org/wiki/Package_Versioning_Examples


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
[-]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[?]: Package functions as described.
[?]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Rpmlint
-------
Checking: golang-github-petar-GoLLRB-devel-0-0.1.git53be0d3.fc27.noarch.rpm
          golang-github-petar-GoLLRB-unit-test-devel-0-0.1.git53be0d3.fc27.x86_64.rpm
          golang-github-petar-GoLLRB-0-0.1.git53be0d3.fc27.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
2 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
golang-github-petar-GoLLRB-unit-test-devel (rpmlib, GLIBC filtered):
    golang-github-petar-GoLLRB-devel

golang-github-petar-GoLLRB-devel (rpmlib, GLIBC filtered):



Provides
--------
golang-github-petar-GoLLRB-unit-test-devel:
    golang-github-petar-GoLLRB-unit-test-devel
    golang-github-petar-GoLLRB-unit-test-devel(x86-64)

golang-github-petar-GoLLRB-devel:
    golang(github.com/petar/GoLLRB/llrb)
    golang-github-petar-GoLLRB-devel



Source checksums
----------------
https://github.com/petar/GoLLRB/archive/53be0d36a84c2a886ca057d34b6aa4468df9ccb4/GoLLRB-53be0d3.tar.gz :
  CHECKSUM(SHA256) this package     : 09ea7feb5458647fe797f22440b1fbeb5fa4e6e2758feaf68c58d74b7fe670d8
  CHECKSUM(SHA256) upstream package : 09ea7feb5458647fe797f22440b1fbeb5fa4e6e2758feaf68c58d74b7fe670d8

Comment 5 Jan Chaloupka 2017-05-03 10:23:16 UTC
> - The file example/ex1.go seems to be documentation, not part of the -devel subpackage code.


If it goes under %doc, it will get installed out of $GOPATH/src directory and becomes uncompileable. The usual use case is to run `go build github.com/petar/GoLLRB/blob/master/example'.

> - There are new guidelines for the Release: tag for snapshots. For instance, the date the snapshot was taken must be present (this should be updated in gofed). See [1] and [2] for reference.

The YYYYMMDD date is impossible to detect without touching the corresponding git repository. It requires cloning a repository locally, checking the commit and accessing its commit date.

Additional, the guidelines are not clear what date to use. Date of the snapshot a.k.a commit date? rpmbuild date? Or any date?

Comment 6 Gwyn Ciesla 2017-05-03 12:41:55 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/golang-github-petar-GoLLRB

Comment 7 Athos Ribeiro 2017-05-03 17:23:54 UTC
> If it goes under %doc, it will get installed out of $GOPATH/src directory
> and becomes uncompileable. The usual use case is to run `go build
> github.com/petar/GoLLRB/blob/master/example'.
> 

One could build it in his home directory, right? It just feels odd to include those examples in the package not as documentation as other non golang packages do. We should compromise to a pattern though (if they are to be packaged in the gopath, maybe this should be pointed in the guidelines).

> The YYYYMMDD date is impossible to detect without touching the corresponding
> git repository. It requires cloning a repository locally, checking the
> commit and accessing its commit date.
> 
> Additional, the guidelines are not clear what date to use. Date of the
> snapshot a.k.a commit date? rpmbuild date? Or any date?

The rpmbuild date seems to be enough [1]

[1]:
< tibbs> The idea is to communicate how old the snapshot is.
< athos> so using the date the packager took the snapshot would be ok, right (although it may be ambiguous as ajax pointed out)?
< tibbs> Yes, that's fine.  It would only matter if you were specifically taking a snapshot of a commit that is older than what's currently at the head.
< tibbs> The whole point, though, is to give humans a relatively easy way to judge that something is "out of date".
< tibbs> Including a commit hash doesn't do that.

Comment 8 Fedora Update System 2017-05-11 13:20:24 UTC
golang-github-petar-GoLLRB-0-0.1.git53be0d3.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-28ba110089

Comment 9 Fedora Update System 2017-05-11 13:20:33 UTC
golang-github-petar-GoLLRB-0-0.1.git53be0d3.el6 has been submitted as an update to Fedora EPEL 6. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-c70875d8ca

Comment 10 Fedora Update System 2017-05-11 13:20:40 UTC
golang-github-petar-GoLLRB-0-0.1.git53be0d3.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-a03ab90854

Comment 11 Fedora Update System 2017-05-11 13:20:46 UTC
golang-github-petar-GoLLRB-0-0.1.git53be0d3.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-646178adbe

Comment 12 Fedora Update System 2017-05-11 13:20:52 UTC
golang-github-petar-GoLLRB-0-0.1.git53be0d3.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-a4823d5756

Comment 13 Fedora Update System 2017-05-12 13:37:04 UTC
golang-github-petar-GoLLRB-0-0.1.git53be0d3.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-28ba110089

Comment 14 Fedora Update System 2017-05-12 19:50:57 UTC
golang-github-petar-GoLLRB-0-0.1.git53be0d3.el6 has been pushed to the Fedora EPEL 6 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-c70875d8ca

Comment 15 Fedora Update System 2017-05-12 19:56:18 UTC
golang-github-petar-GoLLRB-0-0.1.git53be0d3.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-a03ab90854

Comment 16 Fedora Update System 2017-05-12 22:35:06 UTC
golang-github-petar-GoLLRB-0-0.1.git53be0d3.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-646178adbe

Comment 17 Fedora Update System 2017-05-13 01:11:30 UTC
golang-github-petar-GoLLRB-0-0.1.git53be0d3.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-a4823d5756

Comment 18 Fedora Update System 2017-06-15 03:00:31 UTC
golang-github-petar-GoLLRB-0-0.1.git53be0d3.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2017-06-15 04:49:11 UTC
golang-github-petar-GoLLRB-0-0.1.git53be0d3.el6 has been pushed to the Fedora EPEL 6 stable repository. If problems still persist, please make note of it in this bug report.

Comment 20 Fedora Update System 2017-06-15 08:20:19 UTC
golang-github-petar-GoLLRB-0-0.1.git53be0d3.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2017-06-15 09:21:43 UTC
golang-github-petar-GoLLRB-0-0.1.git53be0d3.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.